# This is a sample Python script.

# Press Shift+F10 to execute it or replace it with your code.
# Press Double Shift to search everywhere for classes, files, tool windows, actions, and settings.

def parse_number_sequence(input):
    red_sum = 0
    red_sums = []
    for tile in input:
        red_sum += 1 if tile == "X" else 0
        red_sums.append(red_sum)
    return red_sums, red_sum


def get_square_size_seq(red_sum: int, input_length: int):
    red_square_line = 3
    white_square_line = 1
    usable_squares = []
    white_sum = input_length - red_sum
    white_square = white_square_line ** 2
    red_square = red_square_line ** 2 - white_square
    while white_square <= white_sum and red_square <= red_sum or (red_square <= white_sum and white_square <= red_sum):
        usable_squares.append(red_square_line)
        red_square_line += 1
        white_square_line += 1
        white_square = white_square_line ** 2
        red_square = red_square_line ** 2 - white_square
    return usable_squares


def get_sub_sequence_sum(red_sums, usable_square_line, length: int):
    white_square = (usable_square_line - 2) ** 2
    red_square = usable_square_line ** 2 - white_square
    square = usable_square_line ** 2
    seqs = 0
    for i in range(square-1, length):
        red_tiles = red_sums[i]
        if i - square >= 0:
            red_tiles -= red_sums[i-square]
        if red_tiles == red_square or red_tiles == white_square:
            seqs += 1
    return seqs


if __name__ == '__main__':
    input_length = int(input())
    intel_inside = input()
    red_sums, red_sum = parse_number_sequence(intel_inside)
    usable_square_lines = get_square_size_seq(red_sum, input_length)
    sequences = 0
    for square_line in usable_square_lines:
        sequences += get_sub_sequence_sum(red_sums, square_line, input_length)
    print(sequences)
